#!/bin/sh
cat << 'EEE' > /dev/null
/* getblock.sh
 * Copyright (C) 2018 Momi-g
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
EEE


#xkbの出力から{}ブロックを取り出す。
# ~$ cat unko | ./getblock_xa.sh '$1 == "xkb_symbols" && $2 == "<AD01>" '
# 形式は上記でxkbとad01を含む行をブロックの先頭として検索する。
# 方式は単純に{をカウントしてるだけ。コメントとかリテラルとかは考慮してない
# ので、コメントとかリテラルに{が単発で含まれると失敗する。>> 頭コメントは削除追加。
# 戦闘と尻尾の{}行は削除する。bison?

#オプション追加。 nで頭に行数。Nは前後{}込みで行数付き。ファイル全体に対して。sで最初にヒットしたブロックのみ。
#rはリバースで、ヒットしたブロックを削除して残りを出力する。
#vはrでaboneの表示の有無。vで有り。
buf=`./rdopt ":hnNsrv" "$@"` 
if [ $? -ne 0 ] ; then echo "$0: optErr. see -h. sleep." >/dev/stderr ;sleep 1000; exit 1; fi
eval "$buf"

# echo "--- $0:" >/dev/stderr
# xkbの出力はフォーマットされてるので加工して取り出す
myblkfunc(){
#... awk '$1 == "xkb_symbols" && $2 == "<AD01>" {printf$0 }'
[ "$opt_N" = 1 ] && opt_n=2

sed -e 's/[{]/\
{\
/g
s/[}][ 	]*[;]/\
};\
/g' | awk '$1 != "" {print $0}' | 
awk -v stop="$opt_s" -v num="$opt_n" "$1 { flg=1 ; count=0 }"' 
flg >= 1 {
	#{と}のカウントでblkを判別
	
	buf1=split($0, a, "{") -1
	buf2=split($0, a, "}") -1
	count=count + buf1 - buf2
		#頭と尻尾の無視用
	if (flg == 1 && buf1 > 0){ flg=2; fhit=1 }
		#復帰条件
	if (flg == 2 && count == 0){ flg=0;	if(stop == 1){ exit	} }
	if (num >= 1){ $0 = NR " " $0 }
		#print条件 
	#頭と尻尾はいらない Nは付く。 {のfhitは前処理で単独なのでスキップ。
	if (flg >= 2 && fhit != 1 || num >= 2){ print $0 }
	fhit=0
}' | awk '$1 != "" {print}'	#殻業削除
}


#逆。ヒットしたブロックはカット
myblkfunc_r(){
#... awk '$1 == "xkb_symbols" && $2 == "<AD01>" {printf$0 }'

sed -e 's/[{]/\
{\
/g' | sed -e 's/[}][;]/\
};\
/g' | awk '$1 != "" {print $0}' | 
awk -v stop="$opt_s" -v num="$opt_n" -v disp="$opt_v"  "
BEGIN{flg=0; oflg=0}
$1 {"' flg=1 ; count=0; if( disp == 1 ){print "//---abone"} }
flg == 0 {print $0}
oflg == -1 {print $0; next}

flg >= 1 {
	buf1=split($0, a, "{") -1
	buf2=split($0, a, "}") -1

	count=count + buf1 - buf2
	if (flg == 1 && buf1 > 0){
		flg=2
		fhit=1	#オーバーシュート
	}
	
	#復帰条件
	if (flg == 2 && count == 0){
		flg=0;
		if(stop == 1){
			oflg= 1;	#ワンショット設定。
		}
	}
	if (num == 1){ $0 = NR " " $0 }
	
	#print条件  >> 非表示条件
	if (flg >= 2 && fhit != 1){
		#print $0	#ここでは非表示なので。
	}
	fhit=0
}' | awk ' $1 != "" {print $0}'	#空行削除

}

[ "$opt_r" = "" ] && cat - | awk '$1 != "//" {print $0}' | myblkfunc "$1" 
[ "$opt_r" != "" ] && cat - | awk '$1 != "//" {print $0}' | myblkfunc_r "$1"

# echo "--- $0: end" >/dev/stderr
# cat unko | ./getblock.sh  '$1 == "modifier_map"' -n -s
#cat buf | ./getblock_xa.sh  '$1 == "xkb_keycodes"' -r -v
#cat buf | ./getblock_xa.sh -N
#こんな感じで。ブロック先頭の行にヒットする表現を$1に。引数はawkのヒット条件
#簡単に整形してから処理するので安心。
